%charger la liste des images
clear all
clear figure

f=rdir('*.tif*'); %prends tous les fichiers .tif du dossier dans lequel est enregistré le programme Matlab

%initialisation pour definir le rectangle de travail

image=2; %les i premières images sont claquées donc on commence à celle là
a=imread(f{image}); 
[a,rect]=imcrop(a);%recadrage manuel de la première image, ce même recadrage sera réutilisé par la suite (peut être évité par imdilate)PENSER à faire clic droit après avoir sélectionné le rectangle puis "crop image"
BW=imbinarize(a,20/255);%seuil à 40/255 nuances de gris il sort un carré noir + qq parasites

%b=imerode(a) %pour elargir des bouts de noir qui traine c'est une sorte de
%lissage moyen (inuile ici) "doc imerode" pour plus d'infos
se=strel('disk',2);
b=imdilate(BW,se); %permet de virer les bouts de noirs en lissant grâce au blanc autour
b=1-b; %on inverse l'image pour avoir un carré blanc (pixel=1 au lieu de pixel=0)
c=bwlabel(b);  %doc bwlabel

%nouvelle étape de lissage
s=regionprops(c,'centroid','Area');%renvoie les coordonnées du barycentre  du carré blanc
sa=[s.Area];
Idsa=sa>5;
r=s(Idsa);
centers=r.Centroid;%Renvoie un tableau avec les coordonnées

L=[];
S=[];
len=size(r);
len2=len(1);

for j=1:len2
    S=[S;r(j).Centroid];
end
L=[L,[S]];
x=L(:,1); %renvoie les coordonnées du barycentre  du carré blanc
y=L(:,2);
dt = delaunayTriangulation(L);
Points=dt.Points;
Tri=dt.ConnectivityList;
SEGMENTS=[];
for k=1:length(Tri)
   
    NORM12=sqrt((Points(Tri(k,1),1) - Points(Tri(k,2),1))^2 +(Points(Tri(k,1),2)-Points(Tri(k,2),2))^2);
    NORM13=sqrt((Points(Tri(k,1),1) - Points(Tri(k,3),1))^2 +(Points(Tri(k,1),2)-Points(Tri(k,3),2))^2);
    NORM23=sqrt((Points(Tri(k,3),1) - Points(Tri(k,2),1))^2 +(Points(Tri(k,3),2)-Points(Tri(k,2),2))^2);
    SEGMENTS=[SEGMENTS NORM12];
    SEGMENTS=[SEGMENTS NORM13];
    SEGMENTS=[SEGMENTS NORM23];
end


SEGMENTS=unique(SEGMENTS);
subplot(1,2,1)
triplot(dt,'-r');

title('Triangulation de Delaunay, distance du plus proche voisin')
xlabel('x (pixel)')
ylabel('y (pixel)')



subplot(1,2,2)
histogram(SEGMENTS,'Normalization','probability')
%histogram(SEGMENTS)
title('Proximité')
xlabel('Distance du plus proche voisin (pixel)')
ylabel('Proportion(%)')

% occurences=zeros(length(L),1);
% for k=1:length(L)
%     occurences(k)=sum(sum(dt.ConnectivityList == k));
% end
%occurences


