%refaire csv sur imagej en séparant les séquences pour results1

clear
close

namefile1 = 'Results1.csv';
namefile2 = 'Results 2 (bon truc).csv';

data1=readmatrix(namefile1);
data2=readmatrix(namefile2);

X1 = data1(2:end,3); %en pixel
X2 = data2(2:end,3); %en pixel

Y1 = data1(2:end,4); %en pixel
Y2 = data2(2:end,4); %en pixel

mat_X = [X2];
mat_Y = [Y2];

X = mean(mat_X,2);
Y = mean(mat_Y,2);

dt = 0.1; %écart entre frames en secondes
%taille robot en pixel = 66, taille robot en cm = 4,3
taille_robot_cm = 4,3;
taille_robot_pixel = 66;
a = taille_robot_cm/taille_robot_pixel;
X = a*X;
Y = a*Y;
X1 = a*X1;
X2 = a*X2;

Y1 = a*Y1;
Y2 = a*Y2;



%Calcul vitesse
VX1 = diff(X1)/dt;
VX2 = diff(X2)/dt;
VY1 = diff(Y1)/dt;
VY2 = diff(Y2)/dt;

V1 = sqrt(VX1.^2 + VY1.^2);
V2 = sqrt(VX2.^2 + VY2.^2);



VX = diff(X)/dt;
VY = diff(Y)/dt;

V = sqrt(VX.^2 + VY.^2);
V_moy = mean(V)
V_moy_vec = V_moy*ones(length(V),1);

T = dt*(1:length(V));



%%trajectoire(t)
%taille de l'enceinte : = 1500 pixels * a
taille_enceinte_cm = 1500*a;

close
subplot(3,1,1)
plot(X1,Y1)
hold on
plot(X2,Y2)
xlim([0 taille_enceinte_cm])
ylim([0 taille_enceinte_cm])
title('Trajectoires enceinte au cours du temps 15 robots')
legend('1','2')
xlabel('X(cm)')
ylabel('Y(cm)')

%Vitesse(t)
subplot(3,1,2)
hold on
plot(T,V)
plot(T,V_moy_vec)
xlabel('T(s)')
ylabel('V(cm/s)')

legend('|V(t)|','V mean')

title('Vitesse enceinte 15 robots')

subplot(3,1,3)
plot(V1)
hold on
plot(V2)

xlabel('N°frame')
ylabel('V(cm/s)')
legend('V1','V2')


