%charger la liste des images

f=rdir('*.tif*'); %prends tous les fichiers .tif du dossier dans lequel est enregistré le programme Matlab

%initialisation pour definir le rectangle de travail

image=1; %les i premières images sont claquées donc on commence à celle là
a=imread(f{image}); 
[a,rect]=imcrop(a);%recadrage manuel de la première image, ce même recadrage sera réutilisé par la suite (peut être évité par imdilate)PENSER à faire clic droit après avoir sélectionné le rectangle puis "crop image"
BW=imbinarize(a,20/255);%seuil à 40/255 nuances de gris il sort un carré noir + qq parasites

%b=imerode(a) %pour elargir des bouts de noir qui traine c'est une sorte de
%lissage moyen (inuile ici) "doc imerode" pour plus d'infos
se=strel('disk',2);
b=imdilate(BW,se); %permet de virer les bouts de noirs en lissant grâce au blanc autour
b=1-b; %on inverse l'image pour avoir un carré blanc (pixel=1 au lieu de pixel=0)
c=bwlabel(b);  %doc bwlabel

%nouvelle étape de lissage
s=regionprops(c,'centroid','Area');%renvoie les coordonnées du barycentre  du carré blanc
sa=[s.Area];
Idsa=sa>5;
r=s(Idsa);
centers=r.Centroid;%Renvoie un tableau avec les coordonnées

L=[];
S=[];
len=size(r);
len2=len(1);

for j=1:len2
    S=[S;r(j).Centroid];
end
L=[L,[S]];
x=L(:,1); %renvoie les coordonnées du barycentre  du carré blanc
y=L(:,2);
Voro=voronoi(x,y);
dt = delaunayTriangulation(L);
dt
triplot(dt,'-r');
%hold on
[v,d]=voronoin([x y]);
v
for j=1:length(v)
    if v(j,1)<200
        v(j,1)=Inf;
        v(j,2)=Inf;
    end
    if v(j,1)>800
        v(j,1)=Inf;
        v(j,2)=Inf;
    end    
    if v(j,2)<100
        v(j,1)=Inf;
        v(j,2)=Inf;
    end    
    if v(j,2)>700
        v(j,1)=Inf;
        v(j,2)=Inf;
    end
end
Vx=v(:,1);
Vy=v(:,2);
Vx(Vx == Inf) = [];
Vy(Vy == Inf) = [];

%v=v(v~=Inf);
point_cercle=100;
t = linspace(0,2*pi,point_cercle);
Rayon = 300;
barycentre = [sum(x)/length(x) sum(y)/length(y)];
xc = Rayon*cos(t)+barycentre(1);
yc = Rayon*sin(t)+barycentre(2);
plot(xc,yc)
hold on
Aire = zeros(length(d),1);
for i = 1:length(d)-1
    v1 = v(d{i},1);
    v2 = v(d{i},2);
    u=1;
    distanceN=sqrt((xc(u)-x(i))^2+(yc(u)-y(i))^2);
    distanceN1=sqrt((xc(u)-x(i+1))^2+(yc(u)-y(i+1))^2);
    if distanceN>distanceN1
        while distanceN>distanceN1
            u=u+1;
            if u==point_cercle+1
                u=1;
            end
            distanceN=sqrt((xc(u)-x(i))^2+(yc(u)-y(i))^2);
            distanceN1=sqrt((xc(u)-x(i+1))^2+(yc(u)-y(i+1))^2);
        end
    end
    if distanceN<=distanceN1
        while distanceN<=distanceN1
            u=u+1;
            if u==point_cercle+1
                u=1;
            end
            distanceN=sqrt((xc(u)-x(i))^2+(yc(u)-y(i))^2);
            distanceN1=sqrt((xc(u)-x(i+1))^2+(yc(u)-y(i+1))^2);
        end
    end
    
    
    for k = 2:length(v1)
        if v1(k)==Inf
            v1(k)=xc(u);
            
        end 
        if v2(k)==Inf
            v2(k)=yc(u);
        end
    end
    patch(v1,v2,rand(1,3))
    Aire(i) = polyarea(v1,v2) ;
end


i=40;
v1 = v(d{i},1);  
v2 = v(d{i},2);
u=1;
distanceN=sqrt((xc(u)-x(i))^2+(yc(u)-y(i))^2);
distanceN1=sqrt((xc(u)-x(2))^2+(yc(u)-y(2))^2);
if distanceN>distanceN1
    while distanceN>distanceN1
        u=u+1;
        if u==point_cercle+1
            u=1;
        end
        distanceN=sqrt((xc(u)-x(i))^2+(yc(u)-y(i))^2);
        distanceN1=sqrt((xc(u)-x(2))^2+(yc(u)-y(2))^2);
    end
end
if distanceN<=distanceN1
    while distanceN<=distanceN1
        u=u+1;
        if u==point_cercle+1
            u=1;
        end
        distanceN=sqrt((xc(u)-x(i))^2+(yc(u)-y(i))^2);
        distanceN1=sqrt((xc(u)-x(1))^2+(yc(u)-y(1))^2);
    end
end
    
for k = 1:length(v1)
    if v1(k)==Inf
        v1(k)=xc(u);
    end 
    if v2(k)==Inf
        v2(k)=yc(u);
    end
end
patch(v1,v2,rand(1,3))
Aire(i) = polyarea(v1,v2) ;


