%charger la liste des images

f=rdir('*.tif*'); %prends tous les fichiers .tif du dossier dans lequel est enregistré le programme Matlab
liste_pourcentage=[];
image=1; %les i premières images sont claquées donc on commence à celle là
a=imread(f{image}); 
[a,rect]=imcrop(a);%recadrage manuel de la première image, ce même recadrage sera réutilisé par la suite (peut être évité par imdilate)PENSER à faire clic droit après avoir sélectionné le rectangle puis "crop image"
BW=imbinarize(a,150/255);%seuil à 40/255 nuances de gris il sort un carré noir + qq parasites

%b=imerode(a) %pour elargir des bouts de noir qui traine c'est une sorte de
%lissage moyen (inuile ici) "doc imerode" pour plus d'infos
se=strel('disk',2);
b=imdilate(BW,se); %permet de virer les bouts de noirs en lissant grâce au blanc autour
b=1-b; %on inverse l'image pour avoir un carré blanc (pixel=1 au lieu de pixel=0)
c=bwlabel(b);  %doc bwlabel

%nouvelle étape de lissage
s=regionprops(c,'centroid','Area');%renvoie les coordonnées du barycentre  du carré blanc
sa=[s.Area];
Idsa=(65>sa)&(sa>25);
r=s(Idsa);

%centers=zeros(length(r),2);
%centers(:)=r.Centroid; %Renvoie un tableau avec les coordonnées

L=[];
S=[];
len=size(r);

for j=1:len
    S=[S;r(j).Centroid];
end
%%%%%
%La deuxième valeur sert à définir un rayon autour du point dans lequel on
%est censé trouver des points pour un cluster
%La troisième valeur sert à donner le nombre mi nimal de robot par cluster.
idx = dbscan(S,50,4); % The default distance metric is Euclidean distance
gscatter(S(:,1),S(:,2),idx);
title('DBSCAN Using Euclidean Distance Metric')

% on définit un pourcentage de robots inclus dans des clusters
Taille_echantillon =  len(1); % taille totale échantillon
Taille_clusters=Taille_echantillon - sum(idx == -1); %à chaque image le nb de robots détectés peut être différent, on ne prend ici que celle où
Pourcentage_clustering = Taille_clusters/Taille_echantillon ;
liste_pourcentage = [liste_pourcentage Pourcentage_clustering];



for i=2:length(f)
    i
    %initialisation pour definir le rectangle de travail

    image=i; %les i premières images sont claquées donc on commence à celle là
    a=imread(f{image}); 
    a=imcrop(a,rect);%recadrage manuel de la première image, ce même recadrage sera réutilisé par la suite (peut être évité par imdilate)PENSER à faire clic droit après avoir sélectionné le rectangle puis "crop image"
    BW=imbinarize(a,150/255);%seuil à 40/255 nuances de gris il sort un carré noir + qq parasites

    %b=imerode(a) %pour elargir des bouts de noir qui traine c'est une sorte de
    %lissage moyen (inuile ici) "doc imerode" pour plus d'infos
    se=strel('disk',2);
    b=imdilate(BW,se); %permet de virer les bouts de noirs en lissant grâce au blanc autour
    b=1-b; %on inverse l'image pour avoir un carré blanc (pixel=1 au lieu de pixel=0)
    c=bwlabel(b);  %doc bwlabel
    %nouvelle étape de lissage
    s=regionprops(c,'centroid','Area');%renvoie les coordonnées du barycentre  du carré blanc
    sa=[s.Area];
    Idsa=(65>sa)&(sa>25);
    r=s(Idsa);

    %centers=zeros(length(r),2);
    %centers(:)=r.Centroid; %Renvoie un tableau avec les coordonnées

    L=[];
    S=[];
    len=size(r);

    for j=1:len
        S=[S;r(j).Centroid];
    end
    %%%%%
    %La deuxième valeur sert à définir un rayon autour du point dans lequel on
    %est censé trouver des points pour un cluster
    %La troisième valeur sert à donner le nombre mi nimal de robot par cluster.
    idx = dbscan(S,50,4); % The default distance metric is Euclidean distance
    figure()
    gscatter(S(:,1),S(:,2),idx);
    title('DBSCAN Using Euclidean Distance Metric')

    % on définit un pourcentage de robots inclus dans des clusters
    Taille_echantillon =  len(1); % taille totale échantillon
    Taille_clusters=Taille_echantillon - sum(idx == -1); %à chaque image le nb de robots détectés peut être différent, on ne prend ici que celle où
    Pourcentage_clustering = Taille_clusters/Taille_echantillon ;
    liste_pourcentage = [liste_pourcentage Pourcentage_clustering];
end
pas_de_temps=0.1; %en secondes
temps=[0 : pas_de_temps : (length(f)-1)*pas_de_temps];
plot(temps,smooth(liste_pourcentage))
axis([0 length(f)*pas_de_temps 0 1])
xlabel('temps (en s)')
ylabel('pourcentage de robots inclus dans le cluster')
title('Detection de cluster pour une expérience à 15 robots ')
